var Modal = (function () {
  var overlay = $('<div id="__modal-overlay"></div>').hide(),
    modal = $('<div id="__modal"></div>').hide(),
    content = $('<div class="content"></div>'),
    buttons = $('<div class="buttons"></div>');

  $(document).ready(function () {
    $('body').append(overlay.append(modal.append(content, buttons)));
  });

  var self = {
    open: function (message, choices, callback) {
      var chosen = function (result) {
        return function () {
          if (callback) {
            callback(result);
          }
          self.close();
        }
      };
      $(document).on('keyup.modal', function (e) {
        if (e.keyCode === 27) {
          chosen(null)();
        }
      });
      content.empty().append(message);
      buttons.empty().append(choices.map(function (choice) {
        var button = $('<input type="submit" value="' + choice + '" class="button"/>');
        button.click(chosen(choice));
        return button;
      }));
      buttons.find(".button:not(:first-child)").addClass("button--secondary");
      overlay.fadeIn();
      modal.fadeIn();
      buttons.find(".button:first-child").focus();
    },

    close: function () {
      $(document).unbind('keyup.modal');
      modal.fadeOut();
      overlay.fadeOut();
    },

    bindToSubmit: function (selector, message, choices) {
      $(selector).on('click', function (e) {
        e.preventDefault();
        var form = $(this).parents('form:first');
        self.open(message, choices, function (result) {
          if (result === choices[0]) {
            form.submit();
          }
        });
      });
    }
  };
  return self;
})();
